/* Problem URL: https://codeforces.com/problemset/problem/1872/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    vl a(n);
    cin >> a;

    string b;
    cin >> b;

    while (__builtin_popcount(n) != 1) {
        n++;
        a.push_back(0);
        b.push_back('0');
    }

    vl seg0(n << 1);
    vl seg1(n << 1);
    vi lazy(n << 1);

    nrep(i, n, n << 1) {
        if (b[i - n] == '0') {
            seg0[i] = a[i - n];
        } else {
            seg1[i] = a[i - n];
        }
    }

    for (int i = n - 1; i > 0; i--) {
        seg0[i] = seg0[i * 2] ^ seg0[i * 2 + 1];
        seg1[i] = seg1[i * 2] ^ seg1[i * 2 + 1];
    }

    auto propagate = [&](int i) {
        if (!lazy[i]) {
            return;
        }

        lazy[i] = 0;

        swap(seg0[i], seg1[i]);

        if (i < n) {
            lazy[i * 2] ^= 1;
            lazy[i * 2 + 1] ^= 1;
        }
    };

    function<pair<ll, ll>(int, int, int, int, int)> update = [&](int i, int l, int r, int tl, int tr) -> pair<ll, ll> {
        propagate(i);

        if (l > tr || r < tl) {
            return {seg0[i], seg1[i]};
        }

        if (l >= tl && r <= tr) {
            lazy[i] ^= 1;
            propagate(i);
            return {seg0[i], seg1[i]};
        }

        int mid = (l + r) >> 1;

        auto a1 = update(i * 2, l, mid, tl, tr);
        auto a2 = update(i * 2 + 1, mid + 1, r, tl, tr);

        seg0[i] = a1.first ^ a2.first;
        seg1[i] = a1.second ^ a2.second;

        return {seg0[i], seg1[i]};
    };

    function<pair<ll, ll>(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) -> pair<ll, ll> {
        if (l > tr || r < tl) {
            return {0, 0};
        }

        propagate(i);

        if (l >= tl && r <= tr) {
            return {seg0[i], seg1[i]};
        }

        int mid = (l + r) >> 1;

        auto a1 = query(i * 2, l, mid, tl, tr);
        auto a2 = query(i * 2 + 1, mid + 1, r, tl, tr);

        return {a1.first ^ a2.first, a1.second ^ a2.second};
    };

    int q;
    cin >> q;
    while (q--) {
        int op;
        cin >> op;
        if (op == 1) {
            int l, r;
            cin >> l >> r;
            update(1, 0, n - 1, l - 1, r - 1);
            continue;
        }

        int g;
        cin >> g;

        if (g == 0) {
            cout << query(1, 0, n - 1, 0, n - 1).first << ' ';
        } else {
            cout << query(1, 0, n - 1, 0, n - 1).second << ' ';
        }
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
